
#include "hmg.ch"

MEMVAR aItems

Function Main
Local cServer     := 'localhost'
Local cDataBase   := 'mmdb'
Local cUser       := 'postgres'
Local cPassWord   := 'xxxxxx'
LOCAL cPath := "public"
LOCAL cTable := "TEST"
LOCAL oServer, oTable

PUBLIC aItems  := {}

   oServer := TPQServer():New( cServer, cDatabase, cUser, cPassWord, NIL, cPath )
   IF oServer:NetErr()
      msginfo( oServer:ErrorMsg() )
      QUIT
   ENDIF

   IF .NOT. oServer:TableExists( cTable )
      CreateTable ( cServer , cDataBase , cUser , cPassWord )
   ENDIF

   oTable := oServer:Query( "SELECT * FROM " + cTable + " LIMIT 1000" )
   IF oTable:NetErr()
      msginfo( oTable:ErrorMsg() )
      QUIT
   ENDIF

* ------------------------------------------ *

   DEFINE WINDOW Form_1 ;
      AT 0,0 ;
      WIDTH 800 ;
      HEIGHT 510 ;
      TITLE 'Hello World!' ;
      ON INIT FillArray(oTable) ;
      MAIN
/***
      DEFINE MAIN MENU
         POPUP 'File'
            ITEM 'Append (Alt+A)'       ACTION Form_1.Grid_1.Append
            ITEM 'Save Last Appended Record (Alt+S)'   ACTION Form_1.Grid_1.Save
            ITEM 'Set RecNo'            ACTION Form_1.Grid_1.RecNo := val(InputBox('',''))
            ITEM 'Get RecNo'            ACTION MsgInfo( Str(Form_1.Grid_1.RecNo) )
            ITEM 'Delete'               ACTION Form_1.Grid_1.Delete
            ITEM 'Recall'               ACTION Form_1.Grid_1.Recall
         END POPUP
      END MENU
***/
      @ 10,10 GRID Grid_1 ;
         WIDTH 770 ;
         HEIGHT 440 ;
         HEADERS { 'Code' , 'Name' , 'Salary' , 'Creation' , 'Description' } ;
         WIDTHS { 100 , 120 , 120 , 120 , 120 } ;
         ITEMS aItems ;
         ITEMCOUNT LEN( aItems ) ;

   END WINDOW

   CENTER WINDOW Form_1

   ACTIVATE WINDOW Form_1

Return nil


Function CreateTable ( cServer , cDataBase , cUser , cPassWord )
Local oServer, oQuery, oRow, i
Local cQuery

   oServer := TPQServer():New( cServer , cDataBase , cUser , cPassWord )
   if oServer:NetErr()
      MsgStop ( oServer:Error() )
      Exit Program
   endif

   if oServer:TableExists('TEST')
      oQuery := oServer:Execute('DROP TABLE Test')
      oQuery:Destroy()
   endif

   cQuery := 'CREATE TABLE TEST('
   cQuery += '     CCODE integer not null primary key, '
   cQuery += '     NAME Varchar(40), '
   cQuery += '     SALARY Double Precision, '
   cQuery += '     CREATION Date, '
   cQuery += '     DESCRIPTION text ) '

   oQuery := oServer:Query(cQuery)
   if oQuery:neterr()
      MsgStop ( oQuery:Error() )
   endif
   oQuery:Destroy()

   For i := 1 To 1000
      cQuery := "INSERT INTO test ( ccode , name , salary , creation , description ) VALUES ( " + str(i) + " , 'Name " + str(i) + " ' , " + str(i*1000) + " , '2010-01-01' , 'Some Text...' );"
      oQuery := oServer:Query(cQuery)
      if oQuery:neterr()
         MsgStop ( 'error' )
         Exit
      endif
   next i

   oQuery:destroy()
   oServer:Commit()
   oServer:Destroy()

Return nil

PROCEDURE FillArray(oTable)
LOCAL i, iMax, xLast, xValue

   Domethod( "Form_1", "Grid_1", "DisableUpdate" )
   Domethod( "Form_1", "Grid_1", "DeleteAllItems" )

   iMax := LEN( oTable:Struct())
   DO WHILE .T.
      i := 1
      xLast := {}
      FOR i := 1 TO iMax
         xValue := oTable:FieldGet(i)
         AADD(xLast, xValue )
      NEXT
      Domethod( "Form_1", "Grid_1", "addItem", xLast )
      oTable:Skip()
      IF oTable:Eof()
         EXIT
      ENDIF
   ENDDO
   Domethod( "Form_1", "Grid_1", "EnableUpdate" )
   Domethod( "Form_1", "Grid_1", "Refresh" )
   Domethod( "Form_1", "Grid_1", "SetFocus" )
   DO EVENTS
RETURN

*
*
*